From: "Angus Ainslie (Purism)" <angus@akkea.ca>
Date: Fri, 3 Jan 2020 17:06:33 -0800
Subject: power: supply: max17042_battery: Allow the battery capacity to be
 set

Make PROP_CHARGE_FULL_DESIGN and PROP_CHARGE_FULL writable so that we can set
the battery capacity from userspace.

Signed-off-by: Angus Ainslie (Purism) <angus@akkea.ca>
---
 drivers/power/supply/max17042_battery.c | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

diff --git a/drivers/power/supply/max17042_battery.c b/drivers/power/supply/max17042_battery.c
index 87128cf..3a854a9 100644
--- a/drivers/power/supply/max17042_battery.c
+++ b/drivers/power/supply/max17042_battery.c
@@ -443,9 +443,28 @@ static int max17042_set_property(struct power_supply *psy,
 	struct regmap *map = chip->regmap;
 	int ret = 0;
 	u32 data;
+	u64 data64;
 	int8_t temp;
 
 	switch (psp) {
+	case POWER_SUPPLY_PROP_CHARGE_FULL_DESIGN:
+		ret = regmap_read(map, MAX17042_DesignCap, &data);
+		if (ret < 0)
+			return ret;
+
+		data64 = (u64)val->intval * chip->pdata->r_sns;
+		do_div(data64, 5000000ll);
+		ret = regmap_write(map, MAX17042_DesignCap, (u32)data64);
+		break;
+	case POWER_SUPPLY_PROP_CHARGE_FULL:
+		ret = regmap_read(map, MAX17042_FullCAP, &data);
+		if (ret < 0)
+			return ret;
+
+		data64 = (u64)val->intval * chip->pdata->r_sns;
+		do_div(data64, 5000000ll);
+		ret = regmap_write(map, MAX17042_FullCAP, (u32)data64);
+		break;
 	case POWER_SUPPLY_PROP_TEMP_ALERT_MIN:
 		ret = regmap_read(map, MAX17042_TALRT_Th, &data);
 		if (ret < 0)
@@ -487,6 +506,8 @@ static int max17042_property_is_writeable(struct power_supply *psy,
 	int ret;
 
 	switch (psp) {
+	case POWER_SUPPLY_PROP_CHARGE_FULL_DESIGN:
+	case POWER_SUPPLY_PROP_CHARGE_FULL:
 	case POWER_SUPPLY_PROP_TEMP_ALERT_MIN:
 	case POWER_SUPPLY_PROP_TEMP_ALERT_MAX:
 		ret = 1;
